extends Resource
class_name DragonOutfit


@export var allow_null: bool
@export var outfits: Array[SpriteFrames]
var index: int = 0


func _init(outfits: Array[SpriteFrames] = []):
	self.outfits = outfits


func pick_next() -> SpriteFrames:
	index += 1
	if allow_null:
		return _pick_nullable()
	else:
		return _pick_non_nullable()


func pick_previous() -> SpriteFrames:
	index -= 1
	if allow_null:
		return _pick_nullable()
	else:
		return _pick_non_nullable()


func _pick_nullable() -> SpriteFrames:
	index %= (len(outfits) + 1)
	if index == 0:
		return null
	
	return outfits[index - 1]


func _pick_non_nullable() -> SpriteFrames:
	index %= len(outfits)
	return outfits[index]


func get_texture(index: int) -> SpriteFrames:
	if index < 0 or index >= len(outfits):
		return null
	
	return outfits[index]
